# IBM_PROLOG_BEGIN_TAG
#
# serviceable.event.provider 1.0.0 
#
# Licensed Materials - Property of IBM
#
# Restricted Materials of IBM
#
# COPYRIGHT International Business Machines Corp. 2014,2014
# All Rights Reserved
#
# US Government Users Restricted Rights - Use, duplication or
# disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#
# IBM_PROLOG_END_TAG
'''
Created on Apr 17, 2014
@author: Chen Shao Jie
'''
import Queue
import os
from ConfigParser import ConfigParser


alertQueue = Queue.Queue(0)
MAX_THREAD = 3
threadsNumber = []
stopSendTrap = False
IBM_ENTSPECIFIC_TRAP = str(".1.3.6.1.4.1.2.6.251")
SE_TRAP_EVENT = IBM_ENTSPECIFIC_TRAP + str(".1")
SE_TRAP_EVENT_OBJECTS = IBM_ENTSPECIFIC_TRAP + str(".2")


SE_TRAP_DATETIME = SE_TRAP_EVENT_OBJECTS + str(".1")
SE_ERROR_OCCURTIME = SE_TRAP_EVENT_OBJECTS + str(".2")
SE_LOGID = SE_TRAP_EVENT_OBJECTS + str(".3")
SE_SRC = SE_TRAP_EVENT_OBJECTS + str(".4")
SE_FAILIING_SUB_SYS = SE_TRAP_EVENT_OBJECTS + str(".5")
SE_ACTION_FLG = SE_TRAP_EVENT_OBJECTS + str(".6")
SE_TRAP_APP_ID = SE_TRAP_EVENT_OBJECTS + str(".7")
SE_AGENT_NAME = SE_TRAP_EVENT_OBJECTS + str(".8")
SE_AGENT_TYPE = SE_TRAP_EVENT_OBJECTS + str(".9")
SE_AGENT_HOSTIP = SE_TRAP_EVENT_OBJECTS + str(".10")
SE_AGENT_HOSTNAME = SE_TRAP_EVENT_OBJECTS + str(".11")
SE_SYS_OS_NAME = SE_TRAP_EVENT_OBJECTS + str(".12")
SE_SYS_OS_TYPE = SE_TRAP_EVENT_OBJECTS + str(".13")
SE_SYS_OS_VERSION = SE_TRAP_EVENT_OBJECTS + str(".14")
SE_SYS_TYPE = SE_TRAP_EVENT_OBJECTS + str(".15")
SE_SYS_MODEL = SE_TRAP_EVENT_OBJECTS + str(".16")
SE_SYS_SERIAL_NUMBER = SE_TRAP_EVENT_OBJECTS + str(".17")
SE_SYS_FIRMWARE = SE_TRAP_EVENT_OBJECTS + str(".18")
SE_VMID = SE_TRAP_EVENT_OBJECTS + str(".19")
SE_EXTENDED_ERRORDATA = SE_TRAP_EVENT_OBJECTS + str(".20")
SE_ADDITIONAL_DETAILS = SE_TRAP_EVENT_OBJECTS + str(".21")
SE_TEST_FLG = SE_TRAP_EVENT_OBJECTS + str(".22")


# Traps
IBM_TRAP_SERVICE_AND_CALLHOME = SE_TRAP_EVENT + str(".1")
IBM_TEST_TRAP_SERVICE = SE_TRAP_EVENT + str(".2")


# Trap commands String
CMD_SEND_TRAP = ""

# KVMSA_ROOT = os.path.abspath('.').replace("bin", "")
KVMSA_ROOT = "/opt/ibm/seprovider"
CONFIGFILE = os.path.join(KVMSA_ROOT, "conf", "conf.properties")
config = ConfigParser()
config.read(CONFIGFILE)

# snmptrap path
CMD_PATH = str(config.get("NET_SNMP_BIN", "CMD_STRAP"))
CMD_GERNERATE_SYS_INFO = os.path.join(KVMSA_ROOT, "bin", "sys.discover")
SYS_INFO = "/var/seprovider/data/sysinfo.cached"
INTERVAL = 3600 * 8
HOST_PATH = "/var/seprovider/data/sys.dat"

# test alert
ALERT_FLG = 0
TEST_CONTENT = "testAlert"
HOST_NAME = ""
HOST_IP_PORT = ""
HOST_COMMUNITY = ""
VERSION = ""
AGENT_LOCKS="/var/seprovider/locks"
# agent process id file
AGENT_PID_FILE = os.path.join(AGENT_LOCKS, "agent.pid")
LOG4P_PATH = os.path.join(KVMSA_ROOT, "lib", "log4p.conf")
TEMP_FILE = os.path.join(KVMSA_ROOT, "bin", "tmpfile")
SYS_LOG = "/var/log/messages"
REQ_SERVICE_ACTION_AND_CALL_HOME = ":Service action and call home required"
REQ_SERVICE_ACTION_AND_NO_CALL_HOME = ":Service action required"
MAX_QUEUE_SIZE = 50000
ENABLE_SERVICE="systemctl enable sepctl >/dev/null 2>&1"
DISABLE_SERVICE="systemctl disable sepctl >/dev/null 2>&1"
START_SERVICE="systemctl start sepctl  >/dev/null 2>&1"
STOP_SERVICE="systemctl stop sepctl  >/dev/null 2>&1"
SBIN_PATH="/opt/ibm/seprovider/sbin"
REBOOT_SCRIPT="sepctl"
SYSTEMD_PATH="/usr/lib/systemd/system"
LIBEXEC_PATH="/usr/libexec/seprovider"
STOPPED="serviceable event provider stopped successfully\n"
SEP_NOT_RUNNING="serviceable event provider is not running\n"
SEP_RUNNING="serviceable event provider is running\n"
SEP_UNINSTALLED="serviceable event provider is uninstalled.\n"
LAST_ERROR_FILE="/var/seprovider/logs/lasterror"
LAST_ERROR_FILE_PATH="/var/seprovider/logs"