# IBM_PROLOG_BEGIN_TAG
#
# serviceable.event.provider 1.0.0
#
# Licensed Materials - Property of IBM
#
# Restricted Materials of IBM
#
# COPYRIGHT International Business Machines Corp. 2014,2014
# All Rights Reserved
#
# US Government Users Restricted Rights - Use, duplication or
# disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#
# IBM_PROLOG_END_TAG
'''
Created on Apr 17, 2014
@author: Chen Shao Jie
'''
import os
import SnmpConstants
from SnmpTrapUtils import SnmpTrapUtils

class SnmpSendTrap:

    
    def __init__(self, logEntry):
        self._logEngry = logEntry
        self._snmpTrapInfo = SnmpTrapUtils().getTrapInfo(logEntry)
        self._hostIPPortList = []
        self._communityList = []
        SnmpSendTrap._getHost(self)
    
    def sendTrap(self):
        if SnmpConstants.ALERT_FLG == 0:
            trapOid = SnmpConstants.IBM_TRAP_SERVICE_AND_CALLHOME
        else:
            trapOid = SnmpConstants.IBM_TEST_TRAP_SERVICE
            
        # will exit sending trap if no hostip:port
        if len(self._hostIPPortList) == 0:
            SnmpTrapUtils().activityLog("UNKNOW HOST", False, self._logEngry)
            return
        i = 0
        for __dest in self._hostIPPortList:
            if SnmpConstants.ALERT_FLG == 1:
                targetIP = ""
                if __dest.find("]:") == -1:
                    # IPv4
                    targetIP = __dest.split(":")[0]
                else:
                    # IPv6
                    targetIP = __dest.split("]:")[0].split(":[")[1]
                    
                if  SnmpConstants.HOST_IP_PORT.strip() == targetIP:
                    SnmpTrapUtils().setParameters(__dest, trapOid, self._snmpTrapInfo, self._communityList[i])
                    try:
#                         print (SnmpConstants.CMD_SEND_TRAP)
                        result = os.system(SnmpConstants.CMD_SEND_TRAP)
                        if result == 0:
                            SnmpTrapUtils().activityLog(__dest, True, self._logEngry)
                        else:
                            raise Exception
                    except:
                        SnmpTrapUtils().activityLog(__dest, False, self._logEngry)
                        SnmpTrapUtils().tracelogger().error("SnmpSendTrap::sendTrap send failure")
                    break
            else:
                SnmpTrapUtils().setParameters(__dest, trapOid, self._snmpTrapInfo, self._communityList[i])
                try:
#                     print (SnmpConstants.CMD_SEND_TRAP)
                    result = os.system(SnmpConstants.CMD_SEND_TRAP)
                    if result == 0:
                        SnmpTrapUtils().activityLog(__dest, True, self._logEngry)
                    else:
                        raise Exception
                except:
                    SnmpTrapUtils().activityLog(__dest, False, self._logEngry)
                    SnmpTrapUtils().tracelogger().error("SnmpSendTrap::sendTrap send failure")
                
            i += 1
        
    def _getHost(self):
        try:
            self._fop = open(SnmpConstants.HOST_PATH, "r")
            while True:
                line = self._fop.readline()
                if line:
                    _hostValues = line.strip().split("|")
                    ip = _hostValues[0].split("=")[1]
                    if ip.find(":") == -1:
                        self._hostIPPortList.append(ip + ":" + _hostValues[1].split("=")[1])
                    else:
                        self._hostIPPortList.append("'udp6:[" + ip + "]" + ":" + _hostValues[1].split("=")[1] + "'")
                        
                    self._communityList.append(_hostValues[2].split("=")[1])
                else:
                    break
        except:
            # add log
            SnmpTrapUtils().activityLog("UNKNOW HOST", False, self._logEngry)
            SnmpTrapUtils().tracelogger().error("SnmpSendTrap::_getHost open destination file error")
        finally:
            self._fop.close()
        
